/*{
}
*/





// FONT DRAWING FROM SHADERTOY : https://www.shadertoy.com/view/llSGRm

#define CHAR_SIZE vec2(6, 7)
#define CHAR_SPACING vec2(6, 9)



//Automatically generated from the sprite sheet here: http://uzebox.org/wiki/index.php?title=File:Font6x8.png
vec2 ch_0 = vec2(935221.0,731292.0);
vec2 ch_1 = vec2(274497.0,33308.0);
vec2 ch_2 = vec2(934929.0,1116222.0);
vec2 ch_3 = vec2(934931.0,1058972.0);
vec2 ch_4 = vec2(137380.0,1302788.0);
vec2 ch_5 = vec2(2048263.0,1058972.0);
vec2 ch_6 = vec2(401671.0,1190044.0);
vec2 ch_7 = vec2(2032673.0,66576.0);
vec2 ch_8 = vec2(935187.0,1190044.0);
vec2 ch_9 = vec2(935187.0,1581336.0);


//Extracts bit b from the given number.
//Shifts bits right (num / 2^bit) then ANDs the result with 1 (mod(result,2.0)).
float extract_bit(float n, float b)
{
    b = clamp(b,-1.0,22.0); //Fixes small artefacts on my nexus 7
	return floor(mod(floor(n / pow(2.0,floor(b))),2.0));   
}

//Returns the pixel at uv in the given bit-packed sprite.
float sprite(vec2 spr, vec2 size, vec2 uv)
{
    uv = floor(uv);
    //Calculate the bit to extract (x + y * width) (flipped on x-axis)
    float bit = (size.x-uv.x-1.0) + uv.y * size.x;
    //Clipping bound to remove garbage outside the sprite's boundaries.
    bool bounds = all(greaterThanEqual(uv,vec2(0)));
    bounds = bounds && all(lessThan(uv,size));
    return bounds ? extract_bit(spr.x, bit - 21.0)+extract_bit(spr.y, bit) : 0.0;
}


//Returns the digit sprite for the given number.
vec2 get_digit(int d)
{
    if(d == 0) return ch_0;
    if(d == 1) return ch_1;
    if(d == 2) return ch_2;
    if(d == 3) return ch_3;
    if(d == 4) return ch_4;
    if(d == 5) return ch_5;
    if(d == 6) return ch_6;
    if(d == 7) return ch_7;
    if(d == 8) return ch_8;
    if(d == 9) return ch_9;
    return vec2(0.0);
}

//Prints out the given number starting at pos.
float print_number(int number, vec2 pos, vec2 uv)
{
    vec2 dec_pos = pos;
    float result = 0.;
    for(int i=2; 0<=i; i--)
    {
        int digit = int(   mod(float(number) / pow(10.0, float(i)),10.0)   );
        result += sprite(  get_digit(digit)  ,  CHAR_SIZE  ,  uv-dec_pos  );
        dec_pos.x += CHAR_SPACING.x;
    }
    return result;
}




void main()
{
	float downScale = min(  RENDERSIZE.x/CHAR_SIZE.x/2./2.  ,  RENDERSIZE.y/CHAR_SIZE.y/2.  );
    	vec2 res = RENDERSIZE / downScale;
	vec2 uv = floor(isf_FragNormCoord*res);
    
    	vec2 print_pos = vec2(res.x/2.-CHAR_SIZE.x*3./2.,res.y/2.0-CHAR_SIZE.y/2.);
    	float pixel = print_number(  FRAMEINDEX  ,  floor(print_pos)  ,  uv  ); 
    	
	gl_FragColor = vec4(vec3(pixel), 1.0);
}
